package at.ac.uibk.gitsearch.repository;

import at.ac.uibk.gitsearch.domain.Likes;

import org.springframework.data.jpa.repository.*;
import org.springframework.stereotype.Repository;

/**
 * Spring Data repository for the Likes entity.
 */
@SuppressWarnings("unused")
@Repository
public interface LikesRepository extends JpaRepository<Likes, Long>, JpaSpecificationExecutor<Likes> {

    @Query(value = "SELECT * FROM LIKES u where u.user_id = ?1 and exercise_id = ?2", nativeQuery = true)
    Likes findLikesByUserIDandExerciseID(Integer userID, String ExerciseID);

    @Query(value = "SELECT COUNT(u.exercise_id) FROM LIKES u where exercise_id = ?1", nativeQuery = true)
    Integer findNumberOfLikesByExerciseID(String ExerciseID);
}
