import { ComponentFixture, TestBed } from '@angular/core/testing';
import { ActivatedRoute } from '@angular/router';
import { of } from 'rxjs';

import { GitsearchTestModule } from '../../../test.module';
import { SavedSearchesDetailComponent } from 'app/entities/saved-searches/saved-searches-detail.component';
import { SavedSearches } from 'app/shared/model/saved-searches.model';

describe('Component Tests', () => {
  describe('SavedSearches Management Detail Component', () => {
    let comp: SavedSearchesDetailComponent;
    let fixture: ComponentFixture<SavedSearchesDetailComponent>;
    const route = ({ data: of({ savedSearches: new SavedSearches(123) }) } as any) as ActivatedRoute;

    beforeEach(() => {
      TestBed.configureTestingModule({
        imports: [GitsearchTestModule],
        declarations: [SavedSearchesDetailComponent],
        providers: [{ provide: ActivatedRoute, useValue: route }],
      })
        .overrideTemplate(SavedSearchesDetailComponent, '')
        .compileComponents();
      fixture = TestBed.createComponent(SavedSearchesDetailComponent);
      comp = fixture.componentInstance;
    });

    describe('OnInit', () => {
      it('Should load savedSearches on init', () => {
        // WHEN
        comp.ngOnInit();

        // THEN
        expect(comp.savedSearches).toEqual(jasmine.objectContaining({ id: 123 }));
      });
    });
  });
});
